//+------------------------------------------------------------------+
//|                                                 TickColorCandles |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Denis Zyatkevich"
#property description "  ' '"
#property version   "1.00"
//     
#property indicator_separate_window
//     -  
#property indicator_plots 1
//     4    OHLC   -   
#property indicator_buffers 8
//     -  
#property indicator_type1 DRAW_COLOR_CANDLES
//     
#property indicator_color1 Gray,Red,Green
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//    
enum price_types
  {
   Bid,
   Ask
  };
//   ticks_in_candle   ,
//   
input int ticks_in_candle=16;      //Tick Count in Candles
//   applied_price  price_types 
//       - Bid  Ask
input price_types applied_price=0; // Price
//   path_prefix       
input string path_prefix="";       // FileName Prefix

//  ticks_stored    
int ticks_stored;
//  TicksBuffer[]     ,
//  OpenBuffer[], HighBuffer[], LowBuffer[]  CloseBuffer[]
//     OHLC  , 
// ColorIndexBuffer[]      
double TicksBuffer[],OpenBuffer[],HighBuffer[],LowBuffer[],CloseBuffer[],ColorIndexBuffer[];
double TimeTicks[], TimeCandle[];  //    
//+------------------------------------------------------------------+
//|  OnInit()                                                 |
//+------------------------------------------------------------------+
void OnInit()
  {
   //  OpenBuffer[]   
   SetIndexBuffer(0,OpenBuffer,INDICATOR_DATA);
   //  HighBuffer[]   
   SetIndexBuffer(1,HighBuffer,INDICATOR_DATA);
   //  LowBuffer[]   
   SetIndexBuffer(2,LowBuffer,INDICATOR_DATA);
   //  CloseBuffer[]   
   SetIndexBuffer(3,CloseBuffer,INDICATOR_DATA);
   //  ColorIndexBuffer[]    
   SetIndexBuffer(4,ColorIndexBuffer,INDICATOR_COLOR_INDEX);
   //  TimeCandle[]      
   SetIndexBuffer(5,TimeCandle,INDICATOR_CALCULATIONS);
   //  TimeCandle[]     
   SetIndexBuffer(6,TimeTicks,INDICATOR_CALCULATIONS);
   //  TicksBuffer[]    
   SetIndexBuffer(7,TicksBuffer,INDICATOR_CALCULATIONS);
   //    OpenBuffer[]     
   ArraySetAsSeries(OpenBuffer,true);
   //    HighBuffer[]     
   ArraySetAsSeries(HighBuffer,true);
   //    LowBuffer[]     
   ArraySetAsSeries(LowBuffer,true);
   //    CloseBuffer[]     
   ArraySetAsSeries(CloseBuffer,true);
   //    ColorIndexBuffer[]     
   ArraySetAsSeries(ColorIndexBuffer,true);
   //    TimeCandle[]     
   ArraySetAsSeries(TimeCandle,true);
   //      0 ( Open)  
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
   //      1 ( High)  
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
   //      2 ( Low)  
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);
   //      3 ( Close)  
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);
  }
//+------------------------------------------------------------------+
//|  OnCalculate()                                            |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   //  file_handle -  () ;
   // BidPosition  AskPosition -    Bid  Ask  ;
   // line_string_len -  ,   ,
   // CandleNumber -  ,      OHLC,
   // i -  ;
   int file_handle,BidPosition,AskPosition,line_string_len,CandleNumber,i;
   //  last_price_bid -    Bid
   double last_price_bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   //  last_price_ask -    Ask
   double last_price_ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   //  filename -  , file_buffer -  
   //        
   string filename,file_buffer;
   //    TicksBuffer[]
   ArrayResize(TicksBuffer,ArraySize(CloseBuffer));
   //    TimeCandle[]
   ArrayResize(TimeCandle,ArraySize(CloseBuffer));
   //    TimeTicks[]
   ArrayResize(TimeTicks,ArraySize(CloseBuffer));
   //      path_prefix, 
   //     ".txt"
   StringConcatenate(filename,path_prefix,Symbol(),".txt");
   //      ,  ANSI,    
   file_handle=FileOpen(filename,FILE_READ|FILE_WRITE|FILE_ANSI|FILE_SHARE_READ);
   if(prev_calculated==0)
     {
      //         
      line_string_len=StringLen(FileReadString(file_handle))+2;
      //    (  ,   rates_total/2)
      if(FileSize(file_handle)>(ulong)line_string_len*rates_total/2)
        {
         //       rates_total/2 
         FileSeek(file_handle,-line_string_len*rates_total/2,SEEK_END);
         //       
         FileReadString(file_handle);
        }
      //   
      else
        {
         //      
         FileSeek(file_handle,0,SEEK_SET);
        }
      //    
      ticks_stored=0;
      //    
      while(FileIsEnding(file_handle)==false)
        {
         //    
         file_buffer=FileReadString(file_handle);
         //   ,     6- 
         if(StringLen(file_buffer)>6)
           {
            //    Bid  
            BidPosition=StringFind(file_buffer," ",StringFind(file_buffer," ")+1)+1;
            //    Ask  
            AskPosition=StringFind(file_buffer," ",BidPosition)+1;
            //    Bid,   Bid   TicksBuffer[]
            if(applied_price==0) TicksBuffer[ticks_stored]=StringToDouble(StringSubstr(file_buffer,BidPosition,AskPosition-BidPosition-1));
            //    Ask,   Ask   TicksBuffer[]
            if(applied_price==1) TicksBuffer[ticks_stored]=StringToDouble(StringSubstr(file_buffer,AskPosition));
            //    
            ticks_stored++;
           }
        }
     }
   //       
   else
     {
      //      
      FileSeek(file_handle,0,SEEK_END);
      //     
      TimeTicks[ticks_stored]=TimeCurrent();
      //  ,     
      StringConcatenate(file_buffer,TimeTicks[ticks_stored]," ",DoubleToString(last_price_bid,_Digits)," ",DoubleToString(last_price_ask,_Digits));
      //    
      FileWrite(file_handle,file_buffer);
      //    Bid,    TicksBuffer[]   Bid
      if(applied_price==0) TicksBuffer[ticks_stored]=last_price_bid;
      //    Ask,    TicksBuffer[]   Ask
      if(applied_price==1) TicksBuffer[ticks_stored]=last_price_ask;
      //    
      ticks_stored++;
     }
   //  
   FileClose(file_handle);
   //          
   if(ticks_stored>=rates_total)
     {
      //   tick_stored/2    
      for(i=ticks_stored/2;i<ticks_stored;i++)
        {
         //     TicksBuffer[]  tick_stored/2  
         TicksBuffer[i-ticks_stored/2]=TicksBuffer[i];
         TimeTicks[i-ticks_stored/2]=TimeTicks[i];
        }
      //   
      ticks_stored-=ticks_stored/2;
     }
   //   CandleNumber   
   CandleNumber=-1;
   //        
   for(i=0;i<ticks_stored;i++)
     {
      //      
      if(CandleNumber==(int)(MathFloor((ticks_stored-1)/ticks_in_candle)-MathFloor(i/ticks_in_candle)))
        {
         //        
         CloseBuffer[CandleNumber]=TicksBuffer[i];
         //        ,        
         if(TicksBuffer[i]>HighBuffer[CandleNumber]) HighBuffer[CandleNumber]=TicksBuffer[i];
         //        ,        
         if(TicksBuffer[i]<LowBuffer[CandleNumber]) LowBuffer[CandleNumber]=TicksBuffer[i];
         //   ,        2 ()
         if(CloseBuffer[CandleNumber]>OpenBuffer[CandleNumber]) ColorIndexBuffer[CandleNumber]=2;
         //   ,        1 ()
         if(CloseBuffer[CandleNumber]<OpenBuffer[CandleNumber]) ColorIndexBuffer[CandleNumber]=1;
         //         ,        0 ()
         if(CloseBuffer[CandleNumber]==OpenBuffer[CandleNumber]) ColorIndexBuffer[CandleNumber]=0;
        }
      //      
      else
        {
         //   
         CandleNumber=(int)(MathFloor((ticks_stored-1)/ticks_in_candle)-MathFloor(i/ticks_in_candle));
         //       
         OpenBuffer[CandleNumber]=TicksBuffer[i];
         //       
         HighBuffer[CandleNumber]=TicksBuffer[i];
         //       
         LowBuffer[CandleNumber]=TicksBuffer[i];
         //        
         CloseBuffer[CandleNumber]=TicksBuffer[i];
         //       0 ()
         ColorIndexBuffer[CandleNumber]=0;
         //    :
         TimeCandle[CandleNumber]=TimeTicks[i];
        }
     }
   //    OnCalculate(),  ,   
   return(rates_total);
  }
//+------------------------------------------------------------------+
